

from 臺灣言語工具.音標系統.閩南語.臺灣閩南語羅馬字拼音 import 臺灣閩南語羅馬字拼音
from 臺灣言語工具.基本物件.字 import 字
from 臺灣言語工具.解析整理.解析錯誤 import 解析錯誤


def 全部標點():
    return (
        ('。', '.'), ('，', ','), ('、', ','), ('；', ';'),
        ('：', ':'), ('？', '?'), ('！', '!'),
        # 引號
        ('「', '"'), ('」', '"'), ('『', "'"), ('』', "'"),
        # 夾注號
        ('（', '('), ('）', ')'),
        # 破折號
        ('──', '──'),
        # 刪節號
        ('……', '...'),
        # 連接號
        ('～', '~'),
    )


def 提全部標點():
    全部用字 = set()
    for 一標點 in 全部標點():
        try:
            全部用字.add(
                字(一標點[0], 一標點[1]).看分詞()
            )
        except 解析錯誤:
            print('無法度匯入標點{}{}'.format(一標點[0], 一標點[1]))
    return 全部用字


_全部標點 = 提全部標點()


class 標點:

    @classmethod
    def 全部分詞(cls):
        return _全部標點

    @classmethod
    def 有這个字無(cls, 字物件):
        字臺羅物件 = 字物件.轉音(臺灣閩南語羅馬字拼音)
        # 不檢查輕聲符
        字臺羅物件.音 = 字臺羅物件.音.lstrip('0')
        return 字臺羅物件.看分詞() in cls.全部分詞()
